#ifndef _ISR_DEFS_H_
#define _ISR_DEFS_H_

#include <avr/io.h>
#include <avr/sleep.h>
#include <avr/interrupt.h>

volatile uint8_t IRStatus;
// Status-Bits:
#define B_TIMER0_OVF	0
#define B_TIMER1_OVF	1
#define B_USART_BUSY	3
#define B_USART_RXC		4
#define B_USART_TXC		5
#define B_USART_SERL	6
#define B_USART_SEND	7

#endif	// _ISR_DEFS_H_
