
#ifndef _KONSTANTEN_H_
#define _KONSTANTEN_H_

#include <stdint.h>

typedef enum { false,true } bool;
#define HIGH(x)	(x >> 8)
#define LOW(x)	(x & 0x0F)

#define K_CPUTakt	6144000UL 	//Hz

// Datenbertragung - Adressierung
// Hardware-Adressen
#define K_AdressePlatineWeiche2	0b00101000
#define K_AdressePlatineGW		0b00110000
#define K_AdressePlatineDKW		0b00111000	
// 		0b00101nnn = Weichen normal
//		0b00110nnn = Gleiswechsel
//		0b00111nnn = DKW

//		0b010nnnnn = Gleis
//		0b011nnnnn = Block
//		0b100nnnnn = sonstiges Zubehr

#define K_AdresseMaster		0xFE



	// Aufbau Nachrichtenblock
//       1.Byte: Adresse Empfnger
//       2.Byte: Lnge der Nachricht (komplett!)
//       3.Byte: Adresse Sender
//    ab 4.Byte: Daten
// letztes Byte: Prfsumme

#endif	// _KONSTANTEN_H_
