
//#include <stddef.h>
#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/sleep.h>

#include "Konstanten.h"
#include "USART.h"
#include "ISR_Defs.h"
#include "Timer0.h"

	// Puffer
#define W_BefehlLen		28
#define W_USARTlen		(W_BefehlLen + 4)		// Lnge eines Nachrichtenblocks
uint8_t USARTbuf[W_USARTlen];
// --------------------------------------------------------
	// Aufbau Nachrichtenblock
//       1.Byte: Adresse Empfnger
//       2.Byte: Lnge der Nachricht (komplett!)
//       3.Byte: Adresse Sender
//    ab 4.Byte: Daten
// letztes Byte: Prfsumme

// --------------------------------------------------------
#define ADRESSE_PLATINE		K_AdressePlatineGW
//#define ADRESSE_PLATINE		K_AdressePlatineDKW
//#define ADRESSE_PLATINE		K_AdressePlatineWeiche2
// --------------------------------------------------------
uint8_t verz;


int main()
{
// USART
 USART_Init(USARTbuf,K_AdresseMaster);
// Timer
 Timer0_Init();
 
 DDRB |=(7 << 5);
 PORTB |=(7 << 5);

 /* TEST */ PORTB |= (1 << 7);
 /* TEST */ PORTB |= (1 << 6);
 /* TEST */ PORTB |= (1 << 5);

 sei();
 while(1)
 {
  set_sleep_mode(SLEEP_MODE_IDLE);
  sleep_mode();

  verz++;
  if ( !(IRStatus & (1 << B_USART_BUSY)) )
  {
 /* TEST */ if (!verz)
 /* TEST */ PORTB ^= (1 << 7);
   if ( TasteGedrueckt1(0,1) )
   {
// Probedaten
 /* TEST */ PORTB &= ~(1 << 5);
    USARTbuf[0] = ADRESSE_PLATINE;
    USARTbuf[1] = W_USARTlen;
    for (uint8_t i = 2; i < W_USARTlen-1; i++)
     USARTbuf[i] = i;
    DatenUSARTout();
   }
  }

  if (IRStatus & (1 << B_USART_TXC))
  {
   IRStatus &= ~(1 << B_USART_TXC);
 /* TEST */ PORTB |= (1 << 5);
  }

  if (!verz)
 /* TEST */ PORTB ^= (1 << 6);



 }	// while
 return 0;
};
