
#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/sleep.h>
#include <avr/eeprom.h> 



#include "Konstanten.h"
#define F_CPU	K_CPUTakt
#include <util/delay.h>
#include "USART.h"
#include "ISR_Defs.h"
//#include "Timer0Slave.h"

	// Puffer
#define W_BefehlLen		28
#define W_USARTlen		(W_BefehlLen + 4)		// Lnge eines Nachrichtenblocks
uint8_t USARTbuf[W_USARTlen];

uint8_t EEMEM USARTbuf_EPROM[W_USARTlen] = {1,2,3,4,5,6,7,8,9,10,11,12,13,14};

// --------------------------------------------------------
	// Aufbau Nachrichtenblock
//       1.Byte: Adresse Empfnger
//       2.Byte: Lnge der Nachricht (komplett!)
//       3.Byte: Adresse Sender
//    ab 4.Byte: Daten
// letztes Byte: Prfsumme

// --------------------------------------------------------
#define ADRESSE_PLATINE		K_AdressePlatineGW
//#define ADRESSE_PLATINE		K_AdressePlatineDKW
//#define ADRESSE_PLATINE		K_AdressePlatineWeiche2
// --------------------------------------------------------
uint8_t WJustStatus;

uint32_t verz;
int main()
{
// USART
 USART_Init(USARTbuf,ADRESSE_PLATINE);
// Timer
// Timer0_Init();
 
DDRD|= 1 << 6;

 /* TEST */ 
PORTD &= ~(1 << 6);
_delay_ms(100);
PORTD |= (1 << 6);
_delay_ms(200);
PORTD &= ~(1 << 6);
_delay_ms(200);
 /* TEST */ 
    
 sei();
 while(1)
 {
//  set_sleep_mode(SLEEP_MODE_IDLE);
//  sleep_mode();

//  if (IRStatus & (1 << B_TIMER0_OVF))
//  {
//   IRStatus &= ~(1 << B_TIMER0_OVF);

   if (IRStatus & (1 << B_USART_RXC))
   {
    IRStatus &= ~(1 << B_USART_RXC);

    if (DatenUSARTin())
    {
// kein Fehler
 /* TEST */ 
_delay_ms(100);
PORTD ^= (1 << 6);
_delay_ms(100);
PORTD ^= (1 << 6);
_delay_ms(100);
PORTD ^= (1 << 6);
_delay_ms(100);
PORTD ^= (1 << 6);
_delay_ms(100);
PORTD ^= (1 << 6);
_delay_ms(100);
PORTD ^= (1 << 6);
 /* TEST */ 
    }
    else
    {
// Fehler
 /* TEST */ 
_delay_ms(100);
PORTD ^= (1 << 6);
_delay_ms(100);
PORTD ^= (1 << 6);
_delay_ms(300);
PORTD ^= (1 << 6);
_delay_ms(100);
PORTD ^= (1 << 6);
 /* TEST */ 
    }
   
    eeprom_write_block(USARTbuf,USARTbuf_EPROM,W_USARTlen);
   }
//  }

/*
verz= (verz+1) & 0xFFFFF;
if (!verz)
PORTD ^= (1 << 6);
*/




 }	// while
 return 0;
};

